<template>
  <v-container
    fluid
    color="white"
  >
    <v-row
      v-if="player"
      justify="center"
      align="center"
      class="fill-height"
    >
      <v-col
        cols="12"
        class="text-h5 text-center"
      >
        <h1>{{ player.nickname }}</h1>
      </v-col>
      <v-col
        cols="12"
        class="text-h6 text-center"
      >
        you won {{ stats.winPercentage }}% of your {{ player.numberOfMatchesPlayed }} matches<br/>
        you answered {{ stats.correctAnswerPercentage }}% of your {{ player.totalNumberOfQuestions }} questions correctly
      </v-col>
      <v-col
        cols="12"
        class="text-h7 text-center"
      >
        Trivia Leaderboard, Work In Progress :-)
      </v-col>
    </v-row>
  </v-container>
</template>

<script setup>
import { ref, onMounted } from "vue"
import { get, } from "aws-amplify/api"

let player = ref(null)
let stats = ref({})

onMounted(async () => {
  await loadPlayer()
})

const loadPlayer = async () => {
  try {
    const restOperation = get({
      apiName: "fanfesttrivia",
      path: "/trivia/player",
    })

    const { body } = await restOperation.response
    const thePlayer = await body.json()
    console.log("GET call succeeded")
    console.log(thePlayer)
    player.value = thePlayer

    const ratioToPercentage = ratio => {
      return Math.round(ratio * 1000) / 10
    }

    if(thePlayer.numberOfMatchesPlayed && thePlayer.numberOfMatchesWon) {
      stats.value.winPercentage = ratioToPercentage(thePlayer.numberOfMatchesWon / thePlayer.numberOfMatchesPlayed)
    } else {
      stats.value.winPercentage = 0
    }

    let totalNumberOfQuestions = 0
    if(thePlayer.numberOfQuestionsAnsweredCorrectly !== undefined) {
      totalNumberOfQuestions += thePlayer.numberOfQuestionsAnsweredCorrectly
    }

    if(thePlayer.numberOfQuestionsAnsweredWrongly !== undefined) {
      totalNumberOfQuestions += thePlayer.numberOfQuestionsAnsweredWrongly
    }
    
    stats.value.totalNumberOfQuestions = totalNumberOfQuestions

    if(totalNumberOfQuestions) {
      stats.value.correctAnswerPercentage = ratioToPercentage(thePlayer.numberOfQuestionsAnsweredCorrectly / totalNumberOfQuestions)
    } else {
      stats.value.correctAnswerPercentage = 0
    }
  } catch (error) {
    console.error(error)
  }
}
</script>